<?php

/*************************************************************\
 * Code par Laurent Coustet "ed" <ed@debian-fr.net>          *
 * Ce code sous sous licence GPL.                            *
 * --------------------------------------------------------- *
 *          Copyright (c) 2004 Clarisys.fr                   *
\*************************************************************/
    
class mysql
{
  var $db, $mysql_id, $result, $rows, $data, $a_rows, $rowsperpage;
  var $currentrow, $currentpage, $startrow, $endrow, $insertedid;
  var $codes_http = array ('200' => "HTTP/1.0 200 OK",
                           '401' => "HTTP/1.0 401 Unauthorized",
                           '403' => "HTTP/1.0 403 Forbidden",
                           '404' => "HTTP/1.0 404 Not Found");
  
  function SetHeader ($retval)
    {
      foreach ($this->codes_http as $key => $code)
	{
	  if ($key == $retval)
	    {
	      Debug(3,"header($code) SET.");
	      header($code);
	      return;
	    }
	}
      Debug(1,"Code ReturnValue ($retval) Introuvable dans l'array $codes_http.");
      return False;
    }
  
  function Init_db ($host, $user, $pass, $db) 
    {
      /* on utiliser @ pour ne pas avoir les messages d'erreurs. */
      $this->mysql_id = @mysql_pconnect($host, $user, $pass);
      if($this->mysql_id == false)
	{
	  Debug (1,"Impossible d'tablir la connexion avec ". $host ." en tant que " .$user);
	}
      else
	{
	  Debug (2,"Connexion tablie (MySQL) avec ". $host ." en tant que " .$user);
	}
      Debug (2,"Slection de la base de donne: " .$db);
      @mysql_select_db ($db, $this->mysql_id) or Debug (1,"Impossible de slectionner la base de donne: " .$db);
      return;
    }
  
  function Query ($query) 
    {
      $this->ResetValues();
      Debug (3,"Execution d'une requete SQL: $query");
      $this->result = mysql_query($query, $this->mysql_id) or
	Debug (1,"Impossible d'executer: $query");
      $this->rows = mysql_num_rows($this->result);
      $this->a_rows = mysql_affected_rows($this->mysql_id);
    }
  
# Use this function if the query will only return a
# single data element.
  function QueryItem ($query) 
    {
      $this->ResetValues();
      Debug (3,"Execution d'une requete SQL: $query");
      $this->result = @mysql_query($query, $this->mysql_id) or
	Debug (1,"Impossible d'executer: $query");
      $this->rows = @mysql_num_rows($this->result);
      $this->a_rows = @mysql_affected_rows($this->mysql_id);
      if($this->a_rows>0)
	{
	  $this->data = @mysql_fetch_array($this->result) or
	    Debug (1,"Impossible d'executer: $query");
	  return($this->data[0]);
	}
      else
	{
	  return False;
	}
    }
  
# This function is useful if the query will only return a
# single row.
  function QueryRow ($query) 
    {
      $this->ResetValues();
      Debug (3,"Execution d'une requete SQL: $query");
      $this->result = @mysql_query($query, $this->mysql_id) or
	    Debug (1,"Impossible d'executer: $query");
      $this->rows = @mysql_num_rows($this->result);
      $this->a_rows = @mysql_affected_rows($this->mysql_id);
      if($this->a_rows>0)
	{
	  $this->data = @mysql_fetch_array($this->result) or
	    Debug (1,"Impossible d'executer: $query");
	  return($this->data);
	}
      else
	{
	  return False;
	}
    }
  
  function Insert ($query) 
    {
      Debug (3,"Execution d'une requete SQL: $query");
      if(!($this->result = @mysql_query($query, $this->mysql_id)))
	{
	  Debug (1,"Impossible d'executer: $query");
	  return False;
	}
      $this->a_rows = @mysql_affected_rows($this->mysql_id);
      $this->insertedid = mysql_insert_id($this->mysql_id);
			Debug(3,"Inserted id: ".$this->insertedid);
      return True;
    }
  
  function Update ($query) 
    {
      Debug (3,"Execution d'une requete SQL: $query");
      $this->result = @mysql_query($query, $this->mysql_id) or
	Debug (1,"Impossible d'executer: $query");
      $this->a_rows = @mysql_affected_rows($this->mysql_id);
    }
  
  function Delete ($query) 
    {
      Debug (3,"Execution d'une requete SQL: $query");
      $this->result = @mysql_query($query, $this->mysql_id) or
	Debug (1,"Impossible d'executer: $query");
      $this->a_rows = @mysql_affected_rows($this->mysql_id);
    }
  
  function Fetch ($row) 
    {
      @mysql_data_seek($this->result, $row) or
	Debug (1,"Impossible d'executer Fetch($row)");
      $this->data = @mysql_fetch_array($this->result) or
	Debug (1,"Impossible d'executer Fetch($row)");
    }
  
  function HasNext()
    {
      if($this->currentrow<$this->rows)
	{
	  $this->Fetch($this->currentrow++);
	  return $this->currentrow;
	}
      else
	{
	  return FALSE;
	}
    }
  
  function ResetValues()
    {
      Debug (3,"ResetValues() executed");
      $this->currentrow = 0;
      $this->endrow = 0;
    }
  
  function HasResult()
    {
      if($this->rows > 0)
	{
	  return True;
	} 
      else 
	{
	  return False;
	}
    }
  
} /* MySQL_CLASS */

?>
