<?php

/*************************************************************\
 * Code par Laurent Coustet "ed" <ed@debian-fr.net>          *
 * Ce code sous sous licence GPL.                            *
 * --------------------------------------------------------- *
 *          Copyright (c) 2004 Clarisys.fr                   *
\*************************************************************/
    
	
class utils
{
  var $codes_http = array ('200' => "HTTP/1.0 200 OK",
                           '404' => "HTTP/1.0 404 Not Found",
                           '403' => "HTTP/1.0 403 Forbidden",
                           '401' => "HTTP/1.0 401 Unauthorized");
  
  function SetHeader ($retval)
    {
      foreach ($this->codes_http as $key => $code)
	{
	  if ($key == $retval)
	    {
	      Debug(3,"header($code) SET.");
	      header($code);
	      return;
	    }
	}
      Debug(1,"Code ReturnValue ($retval) Introuvable dans l'array $codes_http.");
      return False;
    }

  /* renvoie vrai si la variable existe dans la session
   * sinon renvoie faux.
   */
  function check_session($var) 
    {
      if(isset($_SESSION[$var])) 
	{
	  return True;
	} 
      else 
	{
	  return False;
	}
    }

  /* enregistre une variable dans la session */
  function set_session($var, $content) 
    {
      Debug(3,"Setting Session var: ".$var." => ".$content);
      $_SESSION[$var] = $content;
    }

  /* renvoie le contenu de la variable */
  function get_session($var) 
    {
      return $_SESSION[$var];
    }
  
  function Redirect($url)
    {
      header("Location: ".$url);
      return;
    }

  function SetCookie($var,$value)
    {
      setcookie($var,$value,time()+constant("COOKIE_DUREE"),constant("COOKIE_PATH"),
		constant("COOKIE_DOMAIN"),constant("COOKIE_SECURE"));      
    }

} /* outils_class */

?>
